#include "alarm.h"

char string[] = "                ";
unsigned char adc;
unsigned char adc2;
unsigned char pinbits;
bit AlarmS;

void main(void)
{
	trisb=0;
    trise.1=0;
    latd.2=0;
    latb.0=0;
    late.1=0;

	delay_ms(500);
    adcon0=0xE9;        //   A/D on, AN5
    adcon1=0x0E;            
	lcd_init();

    delay_ms(100);

	lcd_line1();
	sprintf(string,"PIC18F448",0);
	lcd_string(string);
	delay_ms(1000);

	lcd_line2();
	sprintf(string,"2-Wire 74ALS174N",0);
	lcd_string(string);
	delay_ms(1000);

    delay_s(2);

	lcd_line1();
    ClearLine(0);
	sprintf(string,"Enter Pin:",0);
	lcd_string(string);
	delay_ms(1000);

 
getpin:
        pinbits = 0x00;
        lcd_line2();    
        ClearLine(1);
        int i;

        GetKey();
        if(adc==0x01)
            pinbits.0 = 1;
        sprintf(string,"%01u",adc);
		lcd_string(string);


        GetKey();
        if(adc==0x02)
            pinbits.1 = 1;
        sprintf(string,"%01u",adc);
		lcd_string(string);

        GetKey();
        if(adc==0x03)
            pinbits.2 = 1;
        sprintf(string,"%01u",adc);
		lcd_string(string);

        GetKey();
        if(adc==0x09)
            pinbits.3 = 1;
        sprintf(string,"%01u",adc);
		lcd_string(string);


    if(pinbits<0x0f)
        goto getpin;

        lcd_cmd(0x01);					//clear display
        delay_us(160);

        lcd_line1();    
        ClearLine(0);

        sprintf(string,"Welcome!",adc);
		lcd_string(string);

        delay_s(2);

        lcd_line1();    
        ClearLine(0);

        sprintf(string,"Activate Alarm?",adc);
		lcd_string(string);

        lcd_line2();    

        sprintf(string,"Yes           No",adc);
		lcd_string(string);

AlarmSet:
        AlarmS=0;
        GetKey();

        if(adc==0x0A)
            AlarmS=1;

        if(adc==0x0C)
            AlarmS=1;


         if(AlarmS==0)
            goto AlarmSet;


        if(adc==0x0A){
            AlarmInit();

            lcd_cmd(0x01);					//clear display
	        delay_us(160);

            lcd_line1();    
            ClearLine(0);

            sprintf(string,"All Secure.",adc);
		    lcd_string(string);

        } 
        if(adc==0x0C){
            lcd_cmd(0x01);					//clear display
	        delay_us(160);

            lcd_line1();    
            ClearLine(0);

            sprintf(string,"Alarm OFF.",adc);
		    lcd_string(string);

       }



        while(1){
            //something like wait for isr
        };
        

}	

void AlarmInit (void){
    trisb.0=0;
    latb.0=1;

    trisd.2=0;
    latd.2=1;
    
    delay_ms(500);
    latd.2=0;
}
void GetKey(void)  //adc routine.
{
    delay_ms(500);
    int x;
getit:
    adc=0;
/////////////////////////////////////////////////////
/// DEBOUNCE - Check 2 times and if same continue ///
/////////////////////////////////////////////////////
for(x=0;x<3;x++){ 
 
    delay_ms(10);
    adcon0.2=1;            //start ad conversion.
    while(adcon0.2==1);     //check if conversion is complete.

    adc=adresh;
    adc=adc>>4;

    if(x==1)
        adc2=adc;
}

    if(adc<0x0E){
        if(adc!=adc2)
            goto getit;
    } else {
        goto getit;
    }


}
 

void ClearLine(bit line)
{
if(line==1)
    lcd_line2();
else
    lcd_line1();    

	sprintf(string,"                ",0);
	lcd_string(string);
    delay_us(160);

if(line==1)
    lcd_line2();
else
    lcd_line1();    

}

void lcd_string(char *senpoint)
{
	while(*senpoint != '\0')
	{
		lcd_char(*senpoint);
		senpoint++;
	}
}	

void lcd_line1(void)
{
	lcd_cmd(0x80);
}

void lcd_line2(void)
{
	lcd_cmd(0xc0);
}		

void lcd_cmd(unsigned char letter)
{
	unsigned char temp;
	temp=letter;
	temp=temp>>4;
	lcd_nybble(temp,0);
	temp=letter;
	temp=temp&0x0f;
	lcd_nybble(temp,0);
}

void lcd_char(unsigned char letter)
{
	unsigned char temp;
	temp=letter;
	temp=temp>>4;
	lcd_nybble(temp,1);
	temp=letter;
	temp=temp&0x0f;
	lcd_nybble(temp,1);
}

void lcd_nybble(unsigned char nyb,unsigned char rs)
{
	int i;
	data=0;							//clear the 174
	for(i=0;i<6;i++){				//repeat for 6 bits
		clock=1;clock=0;			//write 0's to the 174
	}
	data=1;							//output the AND value
	clock=1;clock=0;
	data=rs;						//output the RS bit value
	clock=1;clock=0;
	for(i=0;i<4;i++){				//output the nybble
		if((nyb & 0x08) != 0)
			data=1;
		else
			data=0;
		clock=1;clock=0;
		nyb=nyb<<1;
	}
//	clock=1;clock=0;
	e_togg();
}

void lcd_init(void)
{
	lcd_nybble(0x03,0);
	delay_ms(5);
	e_togg();
	delay_us(160);
	e_togg();
	delay_us(160);
	lcd_nybble(0x02,0);
	delay_us(160);
	lcd_cmd(0x28);					//set 4-bit mode and 2 lines
	delay_us(160);
	lcd_cmd(0x10);					//cursor move & shift left
	delay_us(160);
	lcd_cmd(0x06);					//entry mode = increment
	delay_us(160);
	lcd_cmd(0x0d);					//display on - cursor blink on
	delay_us(160);
	lcd_cmd(0x01);					//clear display
	delay_us(160);
}


void e_togg(void)
{
	//data=1;data=0;
    porte.1=1;
    porte.1=0;
}

